
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Java中的守护线程 / 憋错料</title>

    <meta name="description" content="Java中的守护线程 Java中的守护线程 Java中的守护线程与UNIX中的守护线程概念不同,UNIX中的守护线程相当于一项服务,一直运行在后台,而Java中的守护线程是这样定义的: A daemon thread is a thread, that does not prevent the JVM from exiting when the program finishes but the thread is still running. 也就是说,当程序中只有守护线程时,JVM就会自动退出,典型的守护线程就是垃">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Java中的守护线程</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h1><strong>Java中的守护线程</strong></h1>
<p>Java中的守护线程与UNIX中的守护线程概念不同，UNIX中的守护线程相当于一项服务，一直运行在后台，而Java中的守护线程是这样定义的：</p>
<blockquote><p>A daemon thread is a thread, that does not prevent the JVM from exiting when the program finishes but the thread is still running.</p></blockquote>
<p>也就是说，当程序中只有守护线程时，JVM就会自动退出，典型的守护线程就是垃圾回收器（GC）。</p>
<p>当我们创建一个新的线程时，它会继承其父线程的守护线程的状态，就是说其父线程如果是守护线程，其子线程也是守护线程。</p>
<p>守护线程与一般线程的区别是：一般线程如果还没有执行完毕，JVM不会退出，而守护线程不一样，当一般线程全部执行完毕，而守护线程还没有执行完毕，JVM会舍弃执行剩下的守护线程，直接退出虚拟机，因此，与I/O相关的操作不能交给守护线程去操作。</p>
<p>下面看一个例子：</p>
<pre><code>package com.test;

/**
 * Created by z1178 on 2015-08-09.
 */
public class MyTest {
    public static void main(String[] args) {
        new WorkerThread().start();
        try {
            Thread.sleep(7500);
        } catch (InterruptedException e) {
            System.out.println("main thread ending");
        }
    }

}

class WorkerThread extends Thread{
    public WorkerThread() {
        setDaemon(true);
    }
    public void run(){
        int count=0;
        while(true){
            System.out.println("Hello from Worker "+count++);
            try {
                sleep(5000);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }
}
</code></pre>
<p>如果我们将setDaemon设为true或false，会等到不同的结果，如果为true，其结果如下：</p>
<blockquote><p>Hello from Worker 0</p>
<p>Hello from Worker 1</p></blockquote>
<p>说明当主线程执行完毕，JVM就退出了，如果setDaemon设为false，其会一直执行下去，JVM不会退出。</p>
<p>版权声明：本文为博主原创文章，未经博主允许不得转载。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-15 16:54:46 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Java中的守护线程的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0ay2kJ0.html" rel="bookmark">Java中的守护线程和非守护线程（转载）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;什么是守护线程,什么是非守护线程&gt; Java有两种Thread:“守护线程Daemon”(守护线程)与“用户线程User”(非守护线程). 用户线程:非守护线程包括常规的用户线程或诸如用于处理GUI事件的事件调度线程,Java虚拟机在它所有非守护线程已经离开后自动离开. 守护线程:守护线程则是用来服务用户线程的,比如说GC线程.如果没有其他用户线程在运行,那么就没有可服务对象,也就没有理由继续下去.(操作系统里面是没有所谓的守护线程的概念,只有守护进程一说,但是Java语言机制是构建在JVM			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0e1Nxb0.html" rel="bookmark">详解Java中的守护线程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				线程分类 守护线程(即daemon thread),是个服务线程,准确地来说就是服务其他的线程,这是它的作用--而其他的线程只有一种,那就是用户线程.所以java里线程分2种: 用户线程:比如垃圾回收线程,就是最典型的守护线程 守护线程:就是应用程序里的自定义线程 用户线程举例 public class UserTest { public static void main(String[] args) { Thread daemonThread = new Thread(new Runnable			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/382pG2M.html" rel="bookmark">线程基础：线程（3）&mdash;&mdash;JAVA中的基本线程操作（中）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				(接上文&lt;线程基础:线程(2)--JAVA中的基本线程操作(上)&gt;) 1-4.注意synchronized关键字的使用 在前面的文章中我们主要讲解的是线程中&quot;对象锁&quot;的工作原理和操作方式.在讲解synchronized关键字的时候,我们还提到了synchronized关键字可以标注的位置.大家经常看到相当部分的网贴,在它们的代码示例中将synchronized关键字加载到代码的方法体上,然后告诉读者:这个操作是线程安全的.代码可能如下: /** * 这个类的class对象进			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eEZev0.html" rel="bookmark">JAVA学习篇--ThreadLocal，Java中特殊的线程绑定机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在DRP项目中,我们使用了ThreadLocal来创建Connection连接,避免了一直以参数的形式将Connection向下传递(传递connection的目的是由于jdbc事务要求确保使用同一个connection连接).那么ThreadLocal是如果做到的呢?它和同步锁的不同在哪里? 是什么: 对于ThreadLocal看英文单词我们很容易理解为一个线程的本地实现,但是它并不是一个Thread,而是threadlocalvariable(线程局部变量).也许把它命名为ThreadLoc			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDopeY4.html" rel="bookmark">Java 中的守护（Daemon）线程中finally代码块是否执行的问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				http://www.cnblogs.com/luochengor/archive/2011/08/11/2134818.html 这篇文章应该是Thinking in Java 中文版中的一段,关于线程-守护线程(Daemon Thread)的介绍 可能是我理解de不好,我对书对于daemon thread 中的finally是否执行的介绍有点迷糊了,故自己写个方法测试之后才搞明白. 就拿书中的例子做进一步说明.先来看下原文:不看我的罗嗦,可以直接看文章结尾的结论. import java.u			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLPgnEM.html" rel="bookmark">Java daemon thread 守护线程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				守护线程与普通线程写法上基本么啥区别,在启动线程前, 调用线程对象的方法setDaemon(true),则可以将其设置为守护线程. 守护线程使用的情况较少,但并非无用,举例来说,JVM的垃圾回收.内存管理等线程都是守护线程.还有就是在做数据库应用时候,使用的数据库连接池,连接池本身也包含着很多后台线程,监控连接个数.超时时间.状态等等. public final void setDaemon(boolean on) 将该线程标记为守护线程或用户线程.当正在运行的线程都是守护线程时,Java 虚拟			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dEAl93.html" rel="bookmark">JAVA并发编程&mdash;&mdash;守护线程&lpar;Daemon Thread&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在Java中有两类线程:用户线程 (User Thread).守护线程 (Daemon Thread). 所谓守护 线程,是指在程序运行的时候在后台提供一种通用服务的线程,比如垃圾回收线程就是一个很称职的守护者,并且这种线程并不属于程序中不可或缺的部分.因 此,当所有的非守护线程结束时,程序也就终止了,同时会杀死进程中的所有守护线程.反过来说,只要任何非守护线程还在运行,程序就不会终止. 用户线程和守护线程两者几乎没有区别,唯一的不同之处就在于虚拟机的离开:如果用户线程已经全部退出运行了,只剩下			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Moq15D3.html" rel="bookmark">Java中的父线程与子线程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				以前在学习操作系统的时候,一直记得的父线程死后,子线程也消失了.然而今天在查资料中,发现有点疑惑,在此记录一下. Java编写的程序都运行在Java虚拟机(JVM)中,在JVM的内部,程序的多任务是通过线程来实现的. 每用java命令启动一个java应用程序,就会启动一个JVM进程.在同一个JVM进程中,有且只有一个进程,就是它自己.在这个JVM环境中,所有程序代码的运行都是以线程来运行的.JVM找到程序的入口点main(),然后运行main()方法,这样就产生了一个线程,这个线程称之为主线程.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0Ky1qj4.html" rel="bookmark">线程基础：线程（2）&mdash;&mdash;JAVA中的基本线程操作（上）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				文章注明来源:http://blog.csdn.net/yinwenjie,主要供自己学习转载用 1.JAVA中线程的状态 1-1.#对象锁 在Java中每一个对象都有一把‘锁’,这个‘锁’可以是开放状态:也可以由某一个线程(或者多个线程)持有‘钥匙’:一旦在系统中某个对象的‘锁’存在至少一把‘钥匙’,那么任何线程操作这个对象,都必须验证是否有‘钥匙’,如果没有则会报IllegalMonitorStateException异常. 可是‘锁芯’(对象独占权)只有一个,那么可以打开这把锁的多个‘钥匙			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/k0n16oM.html" rel="bookmark" class="title">表单的作用</a>
					<div>
						①input的作用分为:单选按钮.文本框.密码框.复选按钮.隐藏表单域.文本选择框.图片按钮.普通按钮.提交按钮.重置按钮 ②select的作用:可创建单选或多选菜单,含有&lt;option&gt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vEDj60.html" rel="bookmark" class="title">《人，绩效和职业道德》 读后感</a>
					<div>
						我已经认真读了&lt;人,绩效和职业道德&gt;这篇文章,我认为一般有过面向对象编程的人,认为最难也最头疼的就是设计了.一个好的项目,设计至少可以占到百分之五十甚至更多.分工的重要性,说道分工那就不得 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWyJkm3.html" rel="bookmark" class="title">基于科大讯飞语音云windows平台开发</a>
					<div>
						前记: 前段时间公司没事干,突发奇想想做一个语音识别系统,看起来应该很简单的,但做起来却是各种问题,这个对电气毕业的我,却是挺为难的.谷姐已经离我们而去,感谢度娘,感谢CSDN各位大神,好歹也做的是那 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NzgQV4.html" rel="bookmark" class="title">ERP渠道活动管理（二十五）</a>
					<div>
						设计意义: 渠道活动的方式方法多种多样.不过,大至可分为销售型促销与市场型促销(一般来说,销售型促销以完成销售额为唯一目的,以奖励返点为唯一手段,以增大经销商库存为最终结果,短期行为明显.而市场型促销 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xRbwQ4.html" rel="bookmark" class="title">access 连接数据库</a>
					<div>
						前提条件 如果没有安装office的话,需要安装引擎 安装了office就不用安装引擎 连接数据库 Dim plMydb As Microsoft.Office.Interop.Access.Dao. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MomLZQ3.html" rel="bookmark" class="title">lvs使用和管理</a>
					<div>
						lvs是由章文嵩开发出来的,以开源软件的方式,提供负载均衡,其工作方式与iptables非常相似.当用户请求的数据到达本机,经过PREROUTING,来到INPUT表,ipvs会查看所有报文,如果发现 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aAzRQ0.html" rel="bookmark" class="title">杭电ACM HDU 3790 最短路径问题</a>
					<div>
						给你n个点,m条无向边,每条边都有长度d和花费p,给你起点s终点t,要求输出起点到终点的最短距离及其花费,如果最短距离有多条路线,则输出花费最少的. Input 输入n,m,点的编号是1~n,然后是m ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ONGpK0.html" rel="bookmark" class="title">ViewConfiguration滑动参数设置类</a>
					<div>
						/** * 包含了方法和标准的常量用来设置UI的超时.大小和距离 */ public class ViewConfiguration { // 设定水平滚动条的宽度和垂直滚动条的高度,单位是像素px  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NGmGwM.html" rel="bookmark" class="title">Windbg调试Sql Server 进程</a>
					<div>
						http://blog.csdn.net/bcbobo21cn/article/details/52261466 http://www.sqlservercentral.com/blogs/asche ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGalY63.html" rel="bookmark" class="title">为什么虚拟桌面比物理桌面更安全</a>
					<div>
						1        争论 在安全的问题上,物理桌面和虚拟桌面那个更有优势一直以来都存在争论?很多人认为虚拟桌面只是将桌面集中部署到数据中心,本质上没有改变桌面的使用方式,所以安全上没有改善,这种观点的主 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXnwKq3.html" rel="bookmark" class="title">如何将datatable导入到word中</a>
					<div>
						public void ExportDataGridViewToWord(DataTable srcDgv, SaveFileDialog sfile) { if (srcDgv.Rows.Count ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgZOYB4.html" rel="bookmark" class="title">最后一次阅读&mdash;&mdash;13-17章</a>
					<div>
						带着好奇心一口气读完了最后几章.感觉真的不错.人离不开团队,团队也因集体而存在,看完这些,让我更好的为我现在的团队努力. 第13章 这一章主要讲的是软件测试.前面第二章有提到过单预测试.我个人认为单元 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBbY1jM.html" rel="bookmark" class="title">排序&lpar;25&rpar;</a>
					<div>
						#include &lt;iostream&gt; using namespace std; int compare(const void*a, const void *b) { return *(i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBWzbJ0.html" rel="bookmark" class="title">python 统计单词个数---不去重</a>
					<div>
						需求: 统计一篇完全由英文构成的文章中的单词的个数 分析:需要判断什么是单词,并统计判断为单词的元素的个数 需要: Python 正则表达式 简单例子: import re pattern  = re ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02w5vz3.html" rel="bookmark" class="title">struts2 学习笔记</a>
					<div>
						Struts2 学习笔记 在使用J2EE编写网站的时候,我们经常会使用Struts2框架.Struts2的好处就是许多东西已经被封装好了,我们只需要包含给定的jar文件,就能够调用相应的方法和标签.下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47zkq63.html" rel="bookmark" class="title">智能小车十八《如何用上级路由器访问openwrt》</a>
					<div>
						其实用上级路由器访问openwrt很简单,如下图: 在我们刚把720n硬改后,是通过有线连接192.168.1.x来操作路由器的.这时可以进入上面的页面,但没有无线连接. 这时可先加个无线连接,连接到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AnjLvM.html" rel="bookmark" class="title">【html】学习记录-CSS的media queries属性</a>
					<div>
						使用media queries属性可以根据浏览器的宽度自动选择激活需要的CSS定义:         其基本格式如下: @media screen and (min-width: 600px){ /* ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3raAk10.html" rel="bookmark" class="title">javascript不可用的问题探究</a>
					<div>
						昨天在Twitter上的一些有趣的讨论中, 我发现人们对于Web应用和站点对javascript的依赖普遍存在一种疑惑. 这种疑惑一直都存在, 而对我而言, 这个问题随着浏览技术的飞跃发展而集中爆发了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MowZDBM.html" rel="bookmark" class="title">星星拼成的五角星</a>
					<div>
						//shang for (int h1 = 1; h1 &lt;= 5; h1++) { for (int k1 = 0; k1 &lt;= 14 - h1; k1++) { Console.Writ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDDB6oM.html" rel="bookmark" class="title">上传文件的样式</a>
					<div>
						在网上找了很久上传文件的样式,并没有适合自己的,现在推荐一个样式给大家,可以看到自己是否选到文件和文件名.效果如下图所示: html 代码如下: &lt;div class=&quot;uploadi ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
